/* Funciones de apoyo */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include<signal.h>
#include <gtk/gtk.h>

#include "global.h"

volatile int finished;
obex_t *handle = NULL;
int limite_tiempo;

int get_canal_obex (char *mac)	/*sdptool search --bdaddr 00:14:9A:4A:2A:1F OPUSH*/	
{
	char comando [75];
	char texto[100];
	char *channel=NULL;
	FILE *fichero=NULL;
	int canal;
	GtkWidget *dlgError;
	
	sprintf(comando, "sdptool search --bdaddr %s OPUSH > ~/.bloodtooth.log", mac);
	system(comando);
	sprintf(comando, "%s/.bloodtooth.log",getenv("HOME"));
	fichero = fopen (comando,"r");
	
	if (fichero == NULL)
    	{   /* control del error de apertura */
		dlgError = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  "Error: Hubo un error al obtener el canal de transferencia.");
 		gtk_dialog_run (GTK_DIALOG (dlgError));
 		gtk_widget_destroy (dlgError);
    		g_print ("\nError en la apertura. Es posible que el fichero no exista \n");
	        return -1;
    	}
	else
	{
		g_print ("Fichero abierto correctamente\n");
		while (!feof(fichero) && channel==NULL)
		{
			fgets(texto,100,fichero);
			channel=strstr(texto,"Channel: ");	/* Ahora chanel apunta al sitio donde esta "C" */			
		}
		fclose (fichero);
	}
	system("rm ~/.bloodtooth.log");		/* Elimino el fichero */
	
	/* Ahora puedo ponerme a jugar con la cadena y buscar el trozo "Channel: x" */
	if (channel!=NULL)	/* Si no lo encuentra es que la cadena no existe y por tanto no soporta el protocolo */
	{
		if (channel[10]!='\n')	/*Verifica que el canal tenga una o dos cifras */
			canal=((int)(channel[9]-48)*10)+((int)(channel[10]-48));
		else
			canal=(int)channel[9]-48;
	}
	else
		canal=-1;

	return canal;
}

void elimina_lista_dispo (DISPOS *inicio)
{
	DISPOS *actual=inicio;
	
	while (actual!=NULL)
	{
		actual=actual->next;
		free (inicio);
		inicio=actual;
	}
}

char * recorta_cadena (char *cadena)
{
	/* La cadena es una ruta con el fichero, tengo que recortar el nombre del fichero */
	char *subcadena=NULL;
	char *apoyo=NULL;
	char *barra=NULL;
	
	subcadena=cadena;
	
	while (subcadena!=NULL)
	{
		barra=strstr(subcadena,"/");
		if (barra!=NULL)
		{
			subcadena=barra+1;
			apoyo=subcadena;
		}
		else
			subcadena=NULL;
	}
	g_print("%s\n",apoyo);
	return apoyo;
}

void espera_conexiones()
{
	struct sigaction act;
	int dispositivo;
	GtkWidget *dlgError;
	
	/* Compruebo que exista algun dispositivo local */
	dispositivo = hci_get_route(NULL);
	if (dispositivo < 0)
	{
		dlgError = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  "Error: El dispositivo local no esta disponible.");
 		gtk_dialog_run (GTK_DIALOG (dlgError));
 		gtk_widget_destroy (dlgError);
		g_error("[!] Error. Dispositivo Bluetooth local no disponible.\n");
      		exit(1);
	}

	finished=0;
    
    	/* Para controlar el tiempo */
	act.sa_handler= manejador_tiempo;	/* Aqui indico cual es la funcion que se ejecutara cuando alarm de una señal */
	act.sa_flags= 0;
	sigemptyset(&act.sa_mask);
	sigaction(SIGALRM, &act, NULL);
	/*******************************/
	handle = OBEX_Init(OBEX_TRANS_BLUETOOTH, obex_event, 0);	// inicializa obex
	system("sdptool add --channel=10 OPUSH");
	BtOBEX_ServerRegister(handle, NULL, OBEX_PUSH_HANDLE);	// comienza a escuchar
	
	limite_tiempo=0;
	alarm(60);	/*Tiempo en segundos que esperará conexiones */
	btobex_accept(handle);
	
	if (limite_tiempo==1)
		finished=1;

	while (!finished) 	/* Mientras siga habiendo eventos a los que responder */
		OBEX_HandleInput(handle, 1);
		
	OBEX_Cleanup (handle);	//Cierro las conexiones 
}

void manejador_tiempo() 
{
	limite_tiempo=1;
}

/*
 * Función safe_save_file ()
 *
 *   Guardamos el archivo en la carpeta personal
 *
 */
int safe_save_file(char *name, const uint8_t *buf, int len)
{
	int fd;
	int actual;
	char *ruta=NULL;
	char aux[200];
	
	ruta=getenv("HOME"); //Obtengo la ruta de la carpeta personal
	strcpy(aux,ruta);
    strcat(aux,"/"); //Le añadimos una /
	strcat(aux,name);//Y le concatenamos el nombre del archivo
	
	fd = open(aux, O_RDWR | O_CREAT, DEFFILEMODE);

	if ( fd < 0) {
		perror( aux);
		return -1;
	}
	
	actual = write(fd, buf, len);
	close(fd);

	g_print( "Guardado %s (%d bytes)\n", aux, actual);

	return actual;
}

/*
 * Función put_done()
 *
 *    
 *
 */
void put_done(obex_object_t *object)
{
	obex_headerdata_t hv;
	uint8_t hi;
	int hlen;

	const uint8_t *body = NULL;
	int body_len = 0;
	char *name = NULL;
	char *namebuf = NULL;

	while(OBEX_ObjectGetNextHeader(handle, object, &hi, &hv, &hlen))	{
		switch(hi)	{
		case OBEX_HDR_BODY:
			body = hv.bs;
			body_len = hlen;
			break;
		case OBEX_HDR_NAME:
			if( (namebuf = malloc(hlen / 2)))	{
				OBEX_UnicodeToChar(namebuf, hv.bs, hlen);
				name = namebuf;
			}
			break;

		case OBEX_HDR_LENGTH:
			g_print("HEADER_LENGTH = %d\n", hv.bq4);
			break;

		case HEADER_CREATOR_ID:	/* DEFINIDA EN global.h   */
			g_print("CREATORID = %#x\n", hv.bq4);
			break;
		
		default:
			g_print("() Saltado cabecera %02x\n", hi);
		}
	}
	if(!body)	{
		g_print("Obtengo un PUT sin un cuerpo\n");
		return;
	}
	if(!name)	{
		g_print("Obtengo un PUT sin un nombre. Asignandole %s\n", name);
		name = "OBEX_PUT_Unknown_object";

	}
	safe_save_file(name, body, body_len);
	free(namebuf);
}


/*
 * Se le llama cuando se acepta la respuesta
 * Se le llama en OBEX_EV_REQ
 */
void server_request(obex_object_t *object, int event, int cmd)
{ 
	switch(cmd)	{
	case OBEX_CMD_SETPATH:
		g_print("Recibido comando SETPATH \n");
		OBEX_ObjectSetRsp(object, OBEX_RSP_CONTINUE, OBEX_RSP_SUCCESS);
		break;
	case OBEX_CMD_PUT:
		OBEX_ObjectSetRsp(object, OBEX_RSP_CONTINUE, OBEX_RSP_SUCCESS);
		put_done(object);
		break;
	case OBEX_CMD_CONNECT:
		OBEX_ObjectSetRsp(object, OBEX_RSP_SUCCESS, OBEX_RSP_SUCCESS);
		break;
	case OBEX_CMD_DISCONNECT:
		OBEX_ObjectSetRsp(object, OBEX_RSP_SUCCESS, OBEX_RSP_SUCCESS);
		break;
	default:
		g_print("() Denegada %02x peticion\n", cmd);
		OBEX_ObjectSetRsp(object, OBEX_RSP_NOT_IMPLEMENTED, OBEX_RSP_NOT_IMPLEMENTED);
		break;
	}
	return;
}

/*
 *
 * Se le llama cuando las operaciones del servidos finalizan
 *
 */
void server_done(obex_object_t *object, int obex_cmd)
{
	/* Finaliza cuando DISCONNECT ha terminado */
	if(obex_cmd == OBEX_CMD_DISCONNECT)
		finished = 1;
}

/*
 * Funcion obex_event ()
 *
 *    Llamadas cuando ocurre un evento
 *
 */
void obex_event(obex_t *handle, obex_object_t *object, int mode, int event, int obex_cmd, int obex_rsp)
{
	switch (event) {
	case OBEX_EV_PROGRESS:
		g_print(".");
		break;
	case OBEX_EV_REQDONE: 
		g_print("\n");
		/* Entra cuando un comando ha finalizado. */
         	server_done(object, obex_cmd);
		break;
	case OBEX_EV_REQHINT:
		/* Es lo primero que hace al detectar una peticion. */
		switch(obex_cmd) {
		case OBEX_CMD_PUT:	//Sea de desconexión, conexión o lo que sea
		case OBEX_CMD_CONNECT:  // Voy a hacer el OBEX_ObjectSetRsp()
		case OBEX_CMD_DISCONNECT:
			OBEX_ObjectSetRsp(object, OBEX_RSP_CONTINUE, OBEX_RSP_SUCCESS); 
			break;   //Da respuesta a la petición recibida. OBEX_RSP_CONTINUE ----> 0X10 
		default:
			OBEX_ObjectSetRsp(object, OBEX_RSP_NOT_IMPLEMENTED, OBEX_RSP_NOT_IMPLEMENTED);
			break;  //OBEX_RSP_NOT_IMPLEMENTED --->0X51
		}
		break;
	case OBEX_EV_REQ:
		/* Se ejecuta cuando se ha recibido las petición...Despues de OBEX_EV_REQHINT */
		server_request(object, event, obex_cmd);
		break;
	case OBEX_EV_LINKERR:
		g_print("Enlace roto!\n");
		finished = 1;
		break;
	default:
		g_print("Evento desconocido!\n");
		break;
	}
}

